local fd_strcmp = function(txn, s1, s2, n, i, a)
    local v1 = tostring(txn:get_var(s1))
    local v2 = tostring(txn:get_var(s2))

    n = tonumber(n or 0)
    i = tonumber(i or 0)
    a = tonumber(a or 0)

    if n < 1 then
        if a == 1 then
            n = string.len(v1)
        elseif a == 2 then
            n = string.len(v2)
        end
    end

    if n > 0 then
        v1 = string.sub(v1, 1, n)
        v2 = string.sub(v2, 1, n)
    end

    if i > 0 then
        v1 = string.lower(v1)
        v2 = string.lower(v2)
    end

    if v1 < v2 then
		return -1
    elseif v1 == v2 then
		return 0
	else
		return 1
	end
end

core.register_fetches('fd_strcmp', fd_strcmp)
